from Framework import Controller,StaticController,templatepage
from Framework.PluginManager import DeclarePlugin
from cherrypy import expose, request  
from Tools.SecurityModuleCore import RedirectorToLogin
from Tools.SecurityModuleCore import SecurityToken, RedirectToLocalPage, RedirectAway, RedirectorToLogin
from Tools.SecurityModuleCore import Group, Role, NotAuthenticated, FetchFromArgs
from Tools.SecurityModuleCore import is_authorized, is_authenticated, has_site 
from cherrypy.lib import static
import os.path
import pickle
import urllib
import string
from sets import Set

from CondDBCommon import RedirectorToLogin

class GlobalTagCfg(object):
    templatesPath = staticmethod (lambda : os.path.join(__file__.rsplit ("/", 1)[0], "Templates"))


class GlobalTag(Controller):    
    """ Page uses globalTagMain template as index
    """

    def __init__(self, context):
        self.context=context
        Controller.__init__(self,context,__file__)
        self.__basepath = __file__.rsplit('/', 1)[0]
        self.context.addService (GlobalTagCfg())
        self.__appurl=context.CondDBCommonCfg().appserverURL()
        #template variable dict
        self.ret_dict={}
        self.ret_dict['error'] = None
        self.data = {}

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def index(self):
        self._getMainData()
        self.ret_dict['mainData'] = self.data
        return self.templatePage("globalTagIndex", self.ret_dict)

    def _getMainData(self):
        url = self.__appurl+'/globaltag/overview'
        dataHandle = urllib.urlopen(url)
        _ret = dataHandle.read()
        unsorted = pickle.loads(_ret)
        for db, tuples in unsorted.items():
            tuples[0].sort(lambda x, y: cmp(x['tagname'], y['tagname']))
        self.data = unsorted

    def _getTreeData(self, db, trname):
        url = self.__appurl+'/globaltag/getTree?'
        url += 'treename='+trname.lstrip()
        url += '&service='+db.split('/')[0]
        url += '&schema='+db.split('/')[1]
        url += '&viacache=true'
        dataHandle = urllib.urlopen(url)
        _ret = dataHandle.read()
        return pickle.loads(_ret)
       
        
    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def addTree(self, *args, **kwds):
        self.ret_dict['popup'] = "addTree.tmpl"
        self.ret_dict['goalDB'] = kwds['currentDB']
        return self.templatePage("addTree", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def addTreeSubmit(self):
        return self.templatePage("addTreeSubmit", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def addTag(self):
        self.ret_dict['popup'] = "addTag.tmpl"
        return self.templatePage("addTag", self.ret_dict)

###TODO: dodac mozliwosc zmiany nazwy drzewa
    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def addTreeFromScratch(self, *args, **kwds):
        self.tree = Tree([{'nodelabel':'All', 'parentlabel':'ROOT', 'tagid':0}], 'T1')
        self.ret_dict['goalDB'] = kwds['currentDB']
        self.ret_dict['node_list'] = self.tree.serialized
        return self.templatePage("addTreeCommon", self.ret_dict)
    
    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def addTreeFromDummy(self, *args, **kwds):
        self.ret_dict['goalDB'] = kwds['currentDB']
        tree = Tree([{'nodelabel':'All', 'parentlabel':'ROOT', 'tagid':0},{'nodelabel':'Calibration', 'parentlabel':'All', 'tagid':0}, \
                     {'nodelabel':'Alignment', 'parentlabel':'All', 'tagid':0},{'nodelabel':'Test1', 'parentlabel':'Calibration', 'tagid':3}], 'T1')
        self.ret_dict['node_list'] = self.tree.serialized
        return self.templatePage("addTreeCommon", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def editTree(self, *args, **kwds):
        self.ret_dict['currDB']= kwds['currentDB']
        tree = Tree(self._getTreeData(kwds['currentDB'], kwds['treeName']), kwds['treeName'])
        self.ret_dict['node_list'] = tree.serialized
        self.ret_dict['currDB'] = kwds['currentDB']
        self.ret_dict['treeName'] = kwds['treeName']
        return self.templatePage("addTreeCommon", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def viewTree(self, *args, **kwds):
        self.ret_dict['currDB']= kwds['currentDB']
        tree = Tree(self._getTreeData(kwds['currentDB'], kwds['treeName']), kwds['treeName'])
        self.ret_dict['node_list']=tree.serialized
        self.ret_dict['currDB'] = kwds['currentDB']
        self.ret_dict['treeName'] = kwds['treeName']
        return self.templatePage("treeView", self.ret_dict)
    
    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))  
    def addTreeFromExisting(self):
        return self.templatePage("addTreeFromExisting", self.ret_dict)



    """Node operations
    """
    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def insert_node(self, *args, **kwds):
        if kwds.has_key('name'):
            if kwds.has_key('parent_node'):
                self.tree.insert_node(kwds['name'], kwds['parent_node'])
            else:
                self.tree.insert_node(kwds['name'], 'ROOT')
        self.ret_dict['node_list'] = self.tree.serialized        
        return self.templatePage("addTreeCommon", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def edit_node(self, *args, **kwds):
        if kwds.has_key('old_name') and kwds.has_key('new_name'):
            self.tree.edit_node(kwds['old_name'], kwds['new_name'])
        self.ret_dict['node_list'] = self.tree.serialized        
        return self.templatePage("addTreeCommon", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))
    def remove_node(self, *args, **kwds):
        if kwds.has_key('node'):
            if kwds.has_key('del_children'):
                self.tree.remove_node(kwds['node'], True)
            else:
                self.tree.remove_node(kwds['node'])
        self.ret_dict['node_list'] = self.tree.serialized        
        return self.templatePage("addTreeCommon", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))  
    def viewTagDetails(self, *args, **kwds):
        self.ret_dict['currDB']= kwds['currentDB']
        tagList = self.data['oracle://'+ kwds['currentDB']][0]
        if kwds.has_key('tagId'):
            for el in tagList:
                if (str(el['tagid'])==kwds['tagId']):
                    self.ret_dict['tag'] = el     
        else:
            for el in tagList:
                if (el['tagname']==kwds['currTag']):
                    self.ret_dict['tag'] = el
        return self.templatePage("tagInfo", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))  
    def viewIOVDetails(self, *args, **kwds):
        self.ret_dict['currDB']= kwds['currentDB']
        tagList = self.data['oracle://'+ kwds['currentDB']][0]
        if kwds.has_key('tagId'):
            for el in tagList:
                if (str(el['tagid'])==kwds['tagId']):
                    self.ret_dict['tag'] = el     
        else:
            for el in tagList:
                if (el['tagname']==kwds['currTag']):
                    self.ret_dict['tag'] = el
        return self.templatePage("iovInfo", self.ret_dict)

    @expose
    @is_authenticated(onFail=RedirectorToLogin("../GlobalTag/index"))  
    def viewIOVInfo(self):
        self.ret_dict['currDB']= kwds['currentDB']
        self.ret_dict['currTag'] = kwds['currentTag']
        return self.templatePage("iovInfo", self.ret_dict)

DeclarePlugin ("/Controllers/CondDB/GlobalTag",GlobalTag, {"baseUrl": "/GlobalTag"})


class Tree(object):

    def __init__(self, nodeList, treeName):
        self._name = treeName
        self.serialized = self._orderTreeData(nodeList) 


    def _orderTreeData(self, dataList):
        parList = set()
        parList.add('ROOT')
        orderedTree = []
        while (len(dataList) > 0):
            for el in dataList:
                if el['parentlabel'] in parList:
                    orderedTree.append(el)
                    parList.add(el['nodelabel'])
                    dataList.remove(el)
        return orderedTree
    
    def setName(self, name):
        self._name = name
    def name(self):
        return self._name

    def insert_node(self,name, parent, isLeaf = 0):
        newnd={'nodelabel':name, 'parentlabel': parent, 'tagid':isLeaf }
        self.serialized.append(newnd)
    
    def edit_node(self, oldName, newName):
        for nds in self.serialized:
                if nds['nodelabel']== oldName:
                    nds['nodelabel']=newName
                         
    
    def remove_node(self, node, withChildren = False):
            if (withChildren):
                for nds in self.serialized:
                    if nds['nodelabel']==node:
                        self._removeChildren(nds['nodelabel'])
                        self.serialized.remove(nds)
            else:
                for nds in self.serialized:
                     if nds['nodelabel']==node:
                         for el in self.serialized:
                             if el['parentlabel']==node:
                                 el['parentlabel']=nds['parentlabel']
                         self.serialized.remove(nds)

    def _removeChildren(self, parentName):
        for nds in self.serialized:
            if nds['parentlabel'] == parentName:
                self._removeChildren(nds['nodelabel'])
                self.serialized.remove(nds)




